<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Miscellaneous Annotes</TITLE>
<link href="suif1_79.html" rel=Next>
<link href="suif1_77.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_77.html">previous</A>, <A HREF="suif1_79.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H3><A NAME="SEC78" HREF="suif1_toc.html#TOC78">Miscellaneous Annotations</A></H3>
<P>
<A NAME="IDX573"></A>
<A NAME="IDX574"></A>
<A NAME="IDX575"></A>
<A NAME="IDX576"></A>

</P>
<P>
The SUIF library defines a few other annotations to record various
attributes of SUIF programs.  These are straightforward except for the
<CODE>fields</CODE> annotation which is described here in more detail.

</P>
<DL COMPACT>

<DT><CODE>k_line</CODE>
<DD>
<A NAME="IDX577"></A>
This annotation records line numbers from the source code to be used
when debugging the object code.  It is usually attached to a <CODE>mrk</CODE>
instruction.  The first list entry is the integer line number and the
second is the character string for the file name.

<DT><CODE>k_history</CODE>
<DD>
<A NAME="IDX578"></A>
As each SUIF pass runs, the library automatically records the
command-line for the pass as an annotation on the file set entries.
These <CODE>history</CODE> annotations allow you to see how a particular SUIF
file was generated.

<DT><CODE>k_enable_exceptions</CODE>
<DD>
<A NAME="IDX579"></A>
This annotation is attached to a <CODE>proc_symtab</CODE> to indicate which
run-time exceptions should be detected within that procedure.  The
entries on the <CODE>immed</CODE> list are character strings.  The system
currently recognizes <CODE>"int_divide-by-0"</CODE> and <CODE>"int_overflow"</CODE>.
IEEE floating point exceptions need to be added.

<DT><CODE>k_reg_num</CODE>
<DD>
<A NAME="IDX580"></A>
This annotation is attached to variables that represent machine
registers to record the register numbers.  It has one immediate value
which is the integer register number.  The meaning of the register
numbers are machine-dependent.

<DT><CODE>k_fields</CODE>
<DD>
<A NAME="IDX581"></A>
A field within a structure or union variable is specified in SUIF by a
constant offset and a base address.  That is all that is needed to
generate code.  However, if the offset is zero or if the variable is a
union, that information is not sufficient to determine the field.  The
<CODE>fields</CODE> annotation may be used to provide the field names that
were used in the original source code.  The <CODE>immed</CODE> list for one of
these annotations contains the names of the fields being accessed.
(There may be multiple field names because of nested structures or
unions.)
</DL>

<P>
The <CODE>fields</CODE> annotation is somewhat more complicated than the
others.  The difficulty is in defining where this annotation should be
used.  Intuitively, the <CODE>fields</CODE> annotation should be placed on
the first instruction that produces a pointer to the field.  There are
basically three different situations to consider.

</P>
<P>
In the simplest case, a field can be addressed directly with an
<CODE>ldc</CODE> instruction (see section <A HREF="suif1_34.html#SEC34">Load Constant Instructions</A>).  Since that
produces a pointer to the field, a <CODE>fields</CODE> annotation may be
placed on the <CODE>ldc</CODE> instruction.  Of course, the entries on the
annotation must be valid field names for the variable that is addressed.

</P>
<P>
To access a field of a structure or union variable that is referenced by
a pointer, the constant offset must be included with an explicit
<CODE>add</CODE> instruction.  Since the result of
the addition is a pointer to the field, the <CODE>fields</CODE> annotation
should be placed on the <CODE>add</CODE> instruction.  Note that if the field
offset is zero, the <CODE>add</CODE> instruction may be replaced by a
<CODE>cvt</CODE> instruction.  The same rule applies: the <CODE>cvt</CODE>
instruction gets the <CODE>fields</CODE> annotation because it produces a
pointer to the field.

</P>
<P>
For arrays of structures or unions, an <CODE>array</CODE> instruction
(see section <A HREF="suif1_36.html#SEC36">Array Instructions</A>) may include a constant offset for a field
within the array element being addressed, so this is another type of
instruction that may include a <CODE>fields</CODE> annotation.  The entries on
the <CODE>fields</CODE> annotation must be valid fields within the array
element type.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_77.html">previous</A>, <A HREF="suif1_79.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
